// Boost. Range Template Library (rtl)
//
// Copyright 2003 John Torjo (john@torjo.com) and Matthew Wilson (matthew@synesis.com.au)
//
// Permission to copy, use, sell and distribute this software is granted
// provided this copyright notice appears in all copies.
// Permission to modify the code and to distribute modified code is granted
// provided this copyright notice appears in all copies, and a notice
// that the code was modified is included with the copyright notice.
//
// This software is provided "as is" without express or implied warranty,
// and with no claim as to its suitability for any purpose.
 
// See http://www.boost.org for updates, documentation, and revision history.


#ifndef BOOST_RTLRTL_HPP_INCLUDED
#define BOOST_RTLRTL_HPP_INCLUDED

/*
    Note: it's not recommended to include this, since it includes every RangeLib feature.
    This usually increases compilation time.

    Do include this in a pre-compiled header, if you wish.
*/

#include <boost/rangelib/range.hpp>

#include <boost/rangelib/break.hpp>
#include <boost/rangelib/filter.hpp>
#include <boost/rangelib/resort.hpp>
#include <boost/rangelib/transform.hpp>
#include <boost/rangelib/reverse.hpp>
#include <boost/rangelib/indirect.hpp>

#include <boost/rangelib/algo.hpp>


#endif // BOOST_RTL_HPP_INCLUDED
