
#include <boost/rangelib/range.hpp>
#include <boost/rangelib/algo.hpp>
#include <boost/rangelib/break.hpp>
#include <boost/rangelib/generate.hpp>

#include <deque>
#include <vector>
#include <list>
#include <iterator>
#include <iostream>
using namespace boost::rangelib;


#if defined(USING_BREAKED)

namespace {
    bool less_than_17(int val) {
        return val < 17;
    }

    struct next_even {
        next_even() : m_i(0) {}
        int operator() () {
            int i = m_i;
            m_i += 2;
            return i;
        }
    private:
        int m_i;
    };
}

int main() {

    std::vector<int> v;
    v.resize( 20);
    rng::generate( v, next_even() );
    std::cout << "All vector: " << std::endl;
    rng::copy( v, std::ostream_iterator<int>(std::cout, " ") );

    std::cout << "\nOnly first 4 elements: " << std::endl;
    rng::copy( breaked(v, bk_after(4) ), std::ostream_iterator<int>(std::cout, " ") );
    std::cout << "\nBreak at first element >= 17: " << std::endl;
    rng::copy( breaked(v, less_than_17 ), std::ostream_iterator<int>(std::cout, " ") );
    return 0;
}

#endif
